package example.energy;

import schedframe.resources.computing.ComputingResource;
import schedframe.resources.computing.Processor;
import schedframe.resources.computing.profiles.energy.EnergyEvent;
import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
import schedframe.scheduling.manager.tasks.JobRegistry;

public class CPUEnergyEstimationPlugin extends BaseEnergyEstimationPlugin  {

	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
			ComputingResource resource) {
		double powerConsumption;
		Processor cpu = (Processor)resource;
		if(resource.getPowerInterface().getPowerState().equals(StandardPowerStateName.OFF))
			powerConsumption = 0;
		else {
			try {
				return cpu.getPowerInterface().getPowerConsumption(cpu.getPowerInterface().getPState());
			} catch (NoSuchFieldException e) {
				try {
					return cpu.getPowerInterface().getPowerConsumption(StandardPowerStateName.ON);
				} catch (NoSuchFieldException e1) {
					powerConsumption = 1;
				}
			}
		}
		return powerConsumption;
	}

}
